/* VERSION 2.00 */
/*  20.09.2012  */

#include "LCDv1.h"

#define LCD_RS_PIN 		GPIO_Pin_4
#define LCD_E_PIN  		GPIO_Pin_5
#define LCD_D4_PIN 		GPIO_Pin_6
#define LCD_D5_PIN 		GPIO_Pin_7
#define LCD_D6_PIN 		GPIO_Pin_8
#define LCD_D7_PIN 		GPIO_Pin_9

#define LCD_RS_GPIO 	GPIOB
#define LCD_E_GPIO  	GPIOB
#define LCD_D4_GPIO 	GPIOB
#define LCD_D5_GPIO 	GPIOB
#define LCD_D6_GPIO 	GPIOB
#define LCD_D7_GPIO 	GPIOB

void LCD_init(void)
{
	PIN_OUT_PP(LCD_RS_GPIO,LCD_RS_PIN);
	PIN_OUT_PP(LCD_E_GPIO,LCD_E_PIN);
	PIN_OUT_PP(LCD_D4_GPIO,LCD_D4_PIN);
	PIN_OUT_PP(LCD_D5_GPIO,LCD_D5_PIN);
	PIN_OUT_PP(LCD_D6_GPIO,LCD_D6_PIN);
	PIN_OUT_PP(LCD_D7_GPIO,LCD_D7_PIN);
	
	PIN_OFF(LCD_RS_GPIO,LCD_RS_PIN);
	PIN_OFF(LCD_E_GPIO,LCD_E_PIN);
	PIN_OFF(LCD_D4_GPIO,LCD_D4_PIN);
	PIN_OFF(LCD_D5_GPIO,LCD_D5_PIN);
	PIN_OFF(LCD_D6_GPIO,LCD_D6_PIN);
	PIN_OFF(LCD_D7_GPIO,LCD_D7_PIN);
	
	delay_ms(17);
	LCD_Write(0x30);
	delay_ms(1);
	LCD_Write(0x30);
	delay_ms(1);
	LCD_Write(0x30);
	delay_ms(1);
	LCD_Write(0x20);  //4 bit wide bus
	  	
	LCD_Send_Cmd(0x28);	   //4bit wide bus 2 rows
	LCD_Send_Cmd(0x10);
	LCD_Send_Cmd(0x01);
	LCD_Send_Cmd(0x0F);

	LCD_Send_Cmd(LCD_CMD_Cursor_Off);
	LCD_Send_Cmd(LCD_CMD_Clear);
}

void LCD_Write(u8 CMD) 
{	 
	 if ((CMD&(1<<4))!=0) {PIN_ON(LCD_D4_GPIO,LCD_D4_PIN);} 
	 if ((CMD&(1<<5))!=0) {PIN_ON(LCD_D5_GPIO,LCD_D5_PIN);} 
	 if ((CMD&(1<<6))!=0) {PIN_ON(LCD_D6_GPIO,LCD_D6_PIN);} 
	 if ((CMD&(1<<7))!=0) {PIN_ON(LCD_D7_GPIO,LCD_D7_PIN);} 

	 PIN_ON(LCD_E_GPIO,LCD_E_PIN);
	 delay_us(5);
	 PIN_OFF(LCD_E_GPIO,LCD_E_PIN);
	 delay_us(5);

	PIN_OFF(LCD_D4_GPIO,LCD_D4_PIN);
	PIN_OFF(LCD_D5_GPIO,LCD_D5_PIN);
	PIN_OFF(LCD_D6_GPIO,LCD_D6_PIN);
	PIN_OFF(LCD_D7_GPIO,LCD_D7_PIN);
}
void LCD_Send_Cmd(u8 CMD)
{
	delay_ms(5);
	PIN_OFF(LCD_RS_GPIO,LCD_RS_PIN);
	LCD_Write((CMD&0xF0));
	LCD_Write(((CMD&0x0F)<<4));
}

void lcd_set_position(u8 row, u8 colum)
{
	u8 position = 0x80;
	if (row > 0) { position |= 0x40;}
	LCD_Send_Cmd(position | colum);
}

void lcd_write_data(u8 data)
{
	delay_us(50);
	PIN_ON(LCD_RS_GPIO,LCD_RS_PIN);
	LCD_Write((data&0xF0));
	LCD_Write(((data&0x0F)<<4));
}

void lcd_print_char(u8 data)
{
	if (data == '\n')
	{LCD_Send_Cmd(0x80 | 0x40);} else {lcd_write_data(data);}
}

void lcd_print_string(u8 * string)
{
	while (*string != 0x00){ lcd_print_char(*string++);}
}
void lcd_pin_test(void)
{
		PIN_INV(LCD_D4_GPIO,LCD_D4_PIN);
		PIN_INV(LCD_D5_GPIO,LCD_D5_PIN);
		PIN_INV(LCD_D6_GPIO,LCD_D6_PIN);
		PIN_INV(LCD_D7_GPIO,LCD_D7_PIN);
		PIN_INV(LCD_E_GPIO,LCD_E_PIN);
		PIN_INV(LCD_RS_GPIO,LCD_RS_PIN);
}

void lcd_print_value(u32 val)
{
	u8 buffer[10] = {0};
	u8* head = buffer;
	u8 cnt=0;
	if (val!=0)
	{
		while( val )
		{
    		*head++ = (val % 10)["0123456789"];
    		val /= 10;
			cnt++;
		}
		while (cnt!=0){ cnt--; lcd_print_char(buffer[cnt]); }
	}
	else
	{
		lcd_print_char('0');
	}
}

void lcd_print_hex_value(long val)
{
	char buffer[10] = {0};
	char * head = buffer;
	char cnt=0;
	lcd_print_char('0');
	lcd_print_char('x');
	if (val<=9)	lcd_print_char('0');
	if (val!=0)
	{
		while( val )
		{
    		*head++ = (val & 0x0F)["0123456789ABCDEF"];
    		val=val>>4;
			cnt++;
		}
		while (cnt!=0){ cnt--; lcd_print_char(buffer[cnt]); }
	}
	else
	{
		lcd_print_char('0');
	}
	lcd_print_char(' ');
}

