#include "stm32f10x.h"
#include "stm32f10x_gpio.h"
#include "stm32f10x_rcc.h"
#include "stm32_GPIO.h"
#include "delays.h"

#define LCD_CMD_Cursor_Off			   	0x0C
#define LCD_CMD_Blink_Cursor_On		   	0x0F
#define LCD_CMD_Underline_Cursor_On		0x0E
#define LCD_CMD_First_Row				0x80
#define LCD_CMD_Second_Row				0xC0
#define LCD_CMD_Third_Row				0x94
#define LCD_CMD_Fourth_Row				0xD4
#define LCD_CMD_Clear					0x01
#define LCD_CMD_Return_Home				0x02
#define LCD_CMD_Move_Cursor_Left		0x10
#define LCD_CMD_Move_Cursor_Right		0x14
#define LCD_CMD_Turn_On					0x0C
#define LCD_CMD_Turn_Off				0x08
#define LCD_CMD_Shift_Left				0x18
#define LCD_CMD_Shift_Right				0x1C	

void LCD_init(void);
void LCD_Write(u8 CMD);
void LCD_Send_Cmd(u8 CMD);
void lcd_set_position(u8 row, u8 colum);
void lcd_write_data(u8 data);
void lcd_print_char(u8 data);
void lcd_print_string(u8 * string);
void lcd_pin_test(void);
void lcd_print_value(u32 val);
void lcd_print_hex_value(long val);
