//assert_param removed!!!
#include "main.h"

const RTC_t SetDateAndTime={2012, 9, 21, 5, 12, 7, 0, !0};
vu32 packages_received=0;
vu32 packages_freq=0; 
vu8  ShowFlag=0;
u32 packages_received_total=0;
u8 Pipe=0;

int main (void)
{
	u8 Data[16];
	u16 X,Y,Z;
	Init_RCC();
	delay_ms(100);
	Init_GPIO();
	SPI_init_all(SPI1);
	PIN_ON(RF_CSN_PIN);
	RTC_IT_Init();
	LCD_init();
	lcd_set_position(0,0);
	lcd_print_string(" TEST MODULE v2 ");
	lcd_set_position(1,0);
	
	rtc_init();
	if (BUTTON1_PRESSED) SetTime();	
	delay_ms(1000);
	Pipe=Init_RF(SPI1);
	if (Pipe==Config_Reg_Reset_Value) lcd_print_string("NRF24L01 INIT OK");
		else 
			{
				LED_ON(RED_LED); 
				LCD_Send_Cmd(LCD_CMD_Clear);
				lcd_set_position(0,0);
				lcd_print_string(" NRF24L01 ERROR");
				lcd_set_position(1,0);
				lcd_print_string("CONFIG REG: ");
				lcd_print_hex_value(Pipe);
				while(1);
			}
	LED_ON(GREEN_LED);
	delay_ms(1000);
	LED_OFF(GREEN_LED);
	while(1)
	{	
		Pipe=RF_Receive_Data(SPI1, Data, 16);
		if (Pipe!=0xFF)
		{
			/*
			LED_ON(BLUE_LED);
			LCD_Send_Cmd(LCD_CMD_Clear);
			lcd_set_position(0,0);
			lcd_print_string("DATA! Pipe: ");
			lcd_print_value(tmp);
			lcd_set_position(1,0);
			lcd_print_string(Data);
			LED_OFF(BLUE_LED);
			*/
			PIN_INV(BLUE_LED);
			packages_received++;
			packages_received_total++;
			ShowFlag=0;
			
			X=(Data[1]<<8)|Data[0];
			Y=(Data[3]<<8)|Data[2];
			Z=(Data[5]<<8)|Data[4];
			
			LCD_Send_Cmd(LCD_CMD_Clear);
			
			lcd_set_position(0,0);
			lcd_print_string("X:");
			lcd_print_value(X);
			
			lcd_set_position(0,8);
			lcd_print_string("Y:");
			lcd_print_value(Y);

			lcd_set_position(1,0);
			lcd_print_string("Z:");
			lcd_print_value(Z);

			lcd_set_position(1,8);
			lcd_print_string("Pipe:");
			lcd_print_value(Pipe);
}
		//if (BUTTON2_PRESSED|(ShowFlag>1)) ShowTime();
	}
}

void RTC_IT_Handle (void)
{
	  if (packages_received>packages_freq) packages_freq=packages_received;
		packages_received=0;
		ShowFlag++;
}

void Init_RCC (void)
{
	/* PLL Enable for 24MHz HSI OSC */ 
  RCC->CFGR  &= ~RCC_CFGR_PLLSRC;        
  RCC->CR   &= ~RCC_CR_PLLON;            
  RCC->CFGR &= ~RCC_CFGR_PLLMULL;        
  RCC->CFGR |=  RCC_CFGR_PLLMULL6;       
  RCC->CR   |=  RCC_CR_PLLON;            
  while((RCC->CR & RCC_CR_PLLRDY)==0); 
  RCC->CFGR &= ~RCC_CFGR_SW;             
  RCC->CFGR |=  RCC_CFGR_SW_PLL;         
  while((RCC->CFGR&RCC_CFGR_SWS)!=0x08);
  RCC->CFGR &= ~RCC_CFGR_ADCPRE;             
  RCC->CFGR |=  RCC_CFGR_ADCPRE_DIV8;      
	
	/* GPIO RCC ENABLE */
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);

	/* TIM1 ENABLE */
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);

}
void TIM2_Init (void)
{
		TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStruct;
		TIM_TimeBaseInitStruct.TIM_Prescaler=24000;
		TIM_TimeBaseInitStruct.TIM_CounterMode=TIM_CounterMode_Up;
		TIM_TimeBaseInitStruct.TIM_Period=1000;
		TIM_TimeBaseInitStruct.TIM_ClockDivision=TIM_CKD_DIV4;
		TIM_TimeBaseInitStruct.TIM_RepetitionCounter=0;
		TIM_TimeBaseInit(TIM2, &TIM_TimeBaseInitStruct);
		TIM_ITConfig(TIM2, TIM_IT_Update, ENABLE);
		NVIC_EnableIRQ(TIM2_IRQn);
		TIM_Cmd(TIM2, ENABLE);
}

void RTC_IT_Init (void)
{
	RCC->APB1ENR |= RCC_APB1ENR_PWREN | RCC_APB1ENR_BKPEN;
	RTC->CRL  |=  RTC_CRL_CNF; 
	RTC->CRH   =  RTC_CRH_SECIE;
	RTC->CRL  &= ~RTC_CRL_CNF;
	NVIC_EnableIRQ (RTC_IRQn);
}

void Init_GPIO (void)
{
	/* disable JTAG */
  RCC->APB2ENR |=  RCC_APB2ENR_AFIOEN;
  AFIO->MAPR=1<<25; 
	
	/* LEDs Init */
	PIN_OUT_OD(RED_LED);
	PIN_OUT_OD(GREEN_LED);
	PIN_OUT_OD(BLUE_LED);
	
	/* Turn off leds */
	PIN_ON(RED_LED);
	PIN_ON(GREEN_LED);
	PIN_ON(BLUE_LED);
	
	/* Buttons Init */
	PIN_IN_PU(BUTTON1);
	PIN_IN_PU(BUTTON2);	
}

unsigned char Init_RF (SPI_TypeDef* SPIx)
{
	RF_InitTypeDef RF_InitStruct;
	RF_InitStruct.RF_Power_State=RF_Power_On;
	RF_InitStruct.RF_Config=RF_Config_IRQ_RX_On|RF_Config_IRQ_TX_Off|RF_Confing_IRQ_Max_Rt_Off;
	RF_InitStruct.RF_CRC_Mode=RF_CRC16_On;
	RF_InitStruct.RF_Mode=RF_Mode_RX;
	RF_InitStruct.RF_Pipe_Auto_Ack=RF_Pipe1_Ack_Enable;
	RF_InitStruct.RF_Enable_Pipe=RF_Pipe0_Enable|RF_Pipe1_Enable;
	RF_InitStruct.RF_Setup=RF_Setup_5_Byte_Adress;
	RF_InitStruct.RF_TX_Power=RF_TX_Power_High;
	RF_InitStruct.RF_Data_Rate=RF_Data_Rate_1Mbs;
	RF_InitStruct.RF_Channel=0x35;
	RF_InitStruct.RF_RX_Adress_Pipe0[0]='B';
	RF_InitStruct.RF_RX_Adress_Pipe0[1]='A';
	RF_InitStruct.RF_RX_Adress_Pipe0[2]='T';
	RF_InitStruct.RF_RX_Adress_Pipe0[3]='O';
	RF_InitStruct.RF_RX_Adress_Pipe0[4]='N';
	
	RF_InitStruct.RF_RX_Adress_Pipe1[0]='G';
	RF_InitStruct.RF_RX_Adress_Pipe1[1]='A';
	RF_InitStruct.RF_RX_Adress_Pipe1[2]='M';
	RF_InitStruct.RF_RX_Adress_Pipe1[3]='O';
	RF_InitStruct.RF_RX_Adress_Pipe1[4]='N';
	
	RF_InitStruct.RF_RX_Adress_Pipe2=0;
	RF_InitStruct.RF_RX_Adress_Pipe3=0;
	RF_InitStruct.RF_RX_Adress_Pipe4=0;
	RF_InitStruct.RF_RX_Adress_Pipe5=0;
	
	RF_InitStruct.RF_TX_Adress[0]='G';
	RF_InitStruct.RF_TX_Adress[1]='A';
	RF_InitStruct.RF_TX_Adress[2]='M';
	RF_InitStruct.RF_TX_Adress[3]='O';
	RF_InitStruct.RF_TX_Adress[4]='N';
	RF_InitStruct.RF_Payload_Size_Pipe0=16;
	RF_InitStruct.RF_Payload_Size_Pipe1=16;
	RF_InitStruct.RF_Auto_Retransmit_Count=0;
	RF_InitStruct.RF_Auto_Retransmit_Delay=0;
	return RF_Init(SPIx, &RF_InitStruct);
}

void SetTime (void)
{
	LED_ON(RED_LED);
	delay_ms(1000);
	rtc_settime(&SetDateAndTime);
	LED_OFF(RED_LED);
}

void ShowTime (void)
{
	RTC_t DateAndTime;
	rtc_gettime(&DateAndTime);
	
	LED_OFF(BLUE_LED);
	
	LCD_Send_Cmd(LCD_CMD_Clear);
	lcd_set_position(0,0);
	lcd_print_string("Date: ");
	lcd_print_value(DateAndTime.mday);
	lcd_print_string(".");
	if (DateAndTime.month<10) lcd_print_string("0");
	lcd_print_value(DateAndTime.month);
	lcd_print_string(".");
	lcd_print_value(DateAndTime.year);
	lcd_set_position(1,0);
	lcd_print_string("Time: "); 
	if(DateAndTime.hour<10) lcd_print_string("0");
	lcd_print_value(DateAndTime.hour);
	lcd_print_string(":");
	if(DateAndTime.min<10) lcd_print_string("0");
	lcd_print_value(DateAndTime.min);
	lcd_print_string(":");
	if(DateAndTime.sec<10) lcd_print_string("0");
	lcd_print_value(DateAndTime.sec);
	delay_ms(2000);
	
	LCD_Send_Cmd(LCD_CMD_Clear);
	lcd_set_position(0,0);
	lcd_print_string("Data freq: ");
	lcd_print_value(packages_freq);
	lcd_set_position(1,0);
	lcd_print_string("Total: ");
	lcd_print_value(packages_received_total);
	delay_ms(2000);
	ShowFlag=0;
}


