#include "stm32f10x.h"
#include "stm32_GPIO.h"
#include "LCDv1.h"
#include "delays.h"
#include "spi.h"
#include "nrf24l01.h"
#include "rtc.h"
#include "stm32f10x_tim.h"
#include "stm32f10x_rcc.h"


void Init_RCC (void);
void Init_GPIO (void);
void TIM2_Init (void);
unsigned char Init_RF (SPI_TypeDef* SPIx);
void SetTime (void);
void ShowTime (void);
void RTC_IT_Init (void);
void RTC_IT_Handle (void);

extern u8 Received_Data[Max_Data_Len];

#define RED_LED			GPIOB, GPIO_Pin_11
#define GREEN_LED 	GPIOB, GPIO_Pin_12
#define BLUE_LED 		GPIOB, GPIO_Pin_13
#define BUTTON1			GPIOB, GPIO_Pin_14
#define BUTTON2			GPIOB, GPIO_Pin_15

#define RF_CE_PIN					GPIOA, GPIO_Pin_3			
#define RF_IRQ_PIN				GPIOB, GPIO_Pin_0
#define RF_CSN_PIN				GPIOB, GPIO_Pin_1

#define LED_OFF			PIN_ON
#define LED_ON			PIN_OFF
#define BUTTON1_PRESSED !PIN_SYG(BUTTON1)
#define BUTTON2_PRESSED !PIN_SYG(BUTTON2)
